import bpy
import blf

from .. import preferences

str_3 = "\n".join((
        "Modal Uv Shortcuts:",
        "",
        "S              Scale        ",
        "R              Rotate       ",
        "G              Move         ",
        "",
        "Alt+Z          Shading Pie Menu",
        "",
        "Numpad_0       Fit Gizmo to Mesh",
        "Ctrl+Numpad_0  Fit Gizmo to Selected Faces",

        "",
        "Numpad_1       Gizmo 1m*1m ",
        "Numpad_2       Gizmo 2m*2m ",
        "Numpad_3       Gizmo 3m*3m ",
        "etc...",
        "",
        "X              Mirror in X ",
        "Shift+X        Mirror in Y ",
        "Ctrl+X         Mirror in Z ",
        "",
        "Right Click    Gizmo Dimensions",
        "",
        "Shift+Tab      Enable Snap",
        "",
        "T              Text Modal Settings  ",
        "",
        "A or \u25B2 \u25BC       Select other World Gizmos"

        ))


def draw_callback_px(self, context):
    header_height = context.area.regions[0].height

    height = context.area.height + header_height

    # left Top Menu
    x = 150
    y = 190
    # Shadow Value:
    s = 5
    h = 0.0
    a = 0.0
    d = 0.0
    o = 0.5
    # Shadow_Offset Value:
    sx = 2
    sy = -3

    blue = preferences.get_preferences().Text_Color_Modal_Uv

    size_M = preferences.get_preferences().size_modal_shortcuts

    xt = preferences.get_preferences().x_modal_shortcuts
    yt = preferences.get_preferences().y_modal_shortcuts

    xs = preferences.get_preferences().x_position_shortcuts
    ys = height - preferences.get_preferences().y_position_shortcuts
    size_1 = preferences.get_preferences().size_shortcuts

    font_id = 0
    blf.position(font_id, xt, yt, 0)
    blf.size(font_id, size_M)
    blf.color(font_id, blue[0], blue[1], blue[2], blue[3])
    blf.enable(font_id, blf.SHADOW)
    blf.shadow(font_id, 5, 0.0, 0.0, 0.0, .6)
    blf.shadow_offset(font_id, 3, -3)



    font_id2 = 1
    blf.enable(1, blf.WORD_WRAP)
    blf.word_wrap(1, 500)
    blf.position(font_id2, xs, ys, 0)
    blf.size(font_id2, size_1)
    blf.color(font_id2, 1, 1, 1, 1)
    blf.enable(font_id2, blf.SHADOW)
    blf.shadow(font_id2, s, h, a, d, o)
    blf.shadow_offset(font_id2, sx, sy)

    font_id3 = 2
    blf.enable(2, blf.WORD_WRAP)
    blf.word_wrap(2, 800)
    blf.position(font_id3, xt, yt - 40, 0)
    blf.size(font_id3, size_M - 4)
    blf.color(font_id3, 1, 1, 1, 1)
    blf.enable(font_id3, blf.SHADOW)
    blf.shadow(font_id3, s, h, a, d, o)
    blf.shadow_offset(font_id3, sx, sy)

    font_id4 = 3
    blf.position(font_id4, xs + 50, ys + 50, 0)
    blf.size(font_id4, 20)
    blf.color(font_id4, blue[0], blue[1], blue[2], blue[3])

    str_3 = "\n".join((
        "Modal Uv Shortcuts:",
        "",
        "S            Scale        ",
        "R            Rotate       ",
        "G            Move         ",
        "Ctrl+Z       Cancel       ",
        "",
        "A            Select All   ",
        "TAB          Edit Mesh    ",
        "",
        "K            Knife        ",
        "",
        "Numpad_0     Fit Texture to Face",
        "",
        "X,Y          Mirror in X,Y ",
        "",
        "C            Uv Constraint ",
        "",
        "T            Text Modal Settings  ",


    ))

    str_Title = []
    for i, a in enumerate(bpy.context.screen.areas):
        if a.type == 'IMAGE_EDITOR':
            i = i
            a = bpy.context.screen.areas[i]
            s = a.spaces.active
            if s.uv_editor.lock_bounds:
                str_Title = "\n".join((
                    "III  Modal UV  III UV Constraint Activated",
                ))
            else:
                str_Title = "\n".join((
                    "III  Modal UV  III",
                ))

    if preferences.get_preferences().Display_Shortcuts_Modal_Uv:
        blf.draw(font_id2,
                 str_3
                 ),

        blf.draw(font_id3, "Validate: Return, Button5 Mouse or Custom Shortcut\nEscape: Esc")

    blf.draw(font_id, str(str_Title))

    blf.disable(1, blf.WORD_WRAP)
    blf.disable(2, blf.WORD_WRAP)

def draw_modal_gizmo_world_text(self, context):
    npanel_width = context.area.regions[1].width
    transorm_panel_width = context.area.regions[3].width
    header_height = context.area.regions[0].height
    height = context.area.height + header_height
    obj = bpy.context.object

    objp = obj.parent
    gizmos = bpy.data.collections["UV_GIZMO"].all_objects
    Gz = [giz.name for giz in gizmos if giz in objp.children]

    gismo_names = "\n".join(Gz)

    strgiz = "\n".join((
        "",
        "",
        "",
        gismo_names,
    ))

    # left Top Menu
    x = preferences.get_preferences().x_modal_shortcuts
    y = preferences.get_preferences().y_modal_shortcuts
    # Shadow Value:
    s = 5
    h = 0.0
    a = 0.0
    d = 0.0
    o = 0.5
    # Shadow_Offset Value:
    sx = 2
    sy = -3

    BLUE = preferences.get_preferences().Color_World_Gizmo
    size_M = preferences.get_preferences().size_modal_shortcuts

    font_id = 0
    blf.position(font_id, x, y, 0)
    blf.size(font_id, size_M)
    blf.color(font_id, BLUE[0], BLUE[1], BLUE[2], BLUE[3])
    blf.enable(font_id, blf.SHADOW)
    blf.shadow(font_id, 5, 0.0, 0.0, 0.0, .6)
    blf.shadow_offset(font_id, 3, -3)

    xs = preferences.get_preferences().x_position_shortcuts
    ys = height - preferences.get_preferences().y_position_shortcuts
    size_1 = preferences.get_preferences().size_shortcuts

    font_id2 = 1
    blf.enable(1, blf.WORD_WRAP)
    blf.word_wrap(1, 500)
    blf.position(font_id2, xs, ys, 0)
    blf.size(font_id2, size_1)
    blf.color(font_id2, 1, 1, 1, 1)
    blf.enable(font_id2, blf.SHADOW)
    blf.shadow(font_id2, s, h, a, d, o)
    blf.shadow_offset(font_id2, sx, sy)

    font_id3 = 2
    blf.enable(2, blf.WORD_WRAP)
    blf.word_wrap(2, 1200)
    blf.position(font_id3, x, y - 40, 0)
    blf.size(font_id3, size_M-2)
    blf.color(font_id3, 1, 1, 1, 1)
    blf.enable(font_id3, blf.SHADOW)
    blf.shadow(font_id3, s, h, a, d, o)
    blf.shadow_offset(font_id3, sx, sy)

    if preferences.get_preferences().Display_Shortcuts_Modal_Uv:
        blf.draw(font_id3,
                 "Validate: Return, Button5 Mouse or Custom Shortcut\nEscape: Esc")
        blf.draw(font_id2,
                 str_3
                 # strgiz

                 ),
    blf.draw(font_id, "III  Modal World Gizmo  III Only Visible in MATERIAL or RENDER ShadingMode")

    blf.disable(1, blf.WORD_WRAP)
    blf.disable(2, blf.WORD_WRAP)

def draw_modal_gizmo_uv_text(self, context):


    header_height = context.area.regions[0].height
    height = context.area.height + header_height


    # Shadow Value:
    s = 5
    h = 0.0
    a = 0.0
    d = 0.0
    o = 0.5
    # Shadow_Offset Value:
    sx = 2
    sy = -3

    BLUE = preferences.get_preferences().Text_Color_Modal_Uv

    size_M = preferences.get_preferences().size_modal_shortcuts

    xt = preferences.get_preferences().x_modal_shortcuts
    yt = preferences.get_preferences().y_modal_shortcuts

    xs = preferences.get_preferences().x_position_shortcuts
    ys = height - preferences.get_preferences().y_position_shortcuts
    size_1 = preferences.get_preferences().size_shortcuts


    font_id = 0
    blf.position(font_id, xt, yt, 0)
    blf.size(font_id, size_M)
    blf.color(font_id, BLUE[0], BLUE[1], BLUE[2], BLUE[3])
    blf.enable(font_id, blf.SHADOW)
    blf.shadow(font_id, 5, 0.0, 0.0, 0.0, .6)
    blf.shadow_offset(font_id, 3, -3)

    font_id2 = 1
    blf.enable(1, blf.WORD_WRAP)
    blf.word_wrap(1, 900)
    blf.position(font_id2, xs, ys, 0)
    blf.size(font_id2, size_1)
    blf.color(font_id2, 1, 1, 1, 1)
    blf.enable(font_id2, blf.SHADOW)
    blf.shadow(font_id2, s, h, a, d, o)
    blf.shadow_offset(font_id2, sx, sy)

    font_id3 = 2
    blf.enable(2, blf.WORD_WRAP)
    blf.word_wrap(2, 1400)
    blf.position(font_id3, xt, yt - 40, 0)
    blf.size(font_id3, size_M - 4)
    blf.color(font_id3, 1, 1, 1, 1)
    blf.enable(font_id3, blf.SHADOW)
    blf.shadow(font_id3, s, h, a, d, o)
    blf.shadow_offset(font_id3, sx, sy)

    font_id4 = 3
    blf.position(font_id4, xs + 50, ys + 50, 0)
    blf.size(font_id4, 20)
    blf.color(font_id4, BLUE[0], BLUE[1], BLUE[2], BLUE[3])


    if preferences.get_preferences().Display_Shortcuts_Modal_Uv:
        blf.draw(font_id3,
                 "Validate: Return, Button5 Mouse or Custom Shortcut\nEscape: Esc")
        blf.draw(font_id2,
                 str_3
                 ),
    blf.draw(font_id, "III  Modal UV Gizmo  III")

    blf.disable(1, blf.WORD_WRAP)
    blf.disable(2, blf.WORD_WRAP)
def draw_modal_displace(self, context):
    npanel_width = context.area.regions[1].width
    transorm_panel_width = context.area.regions[3].width
    header_height = context.area.regions[0].height
    height = context.area.height + header_height

    # left Top Menu
    x = 150
    y = 120
    # Shadow Value:
    s = 5
    h = 0.0
    a = 0.0
    d = 0.0
    o = 0.5
    # Shadow_Offset Value:
    sx = 2
    sy = -3

    pink_mod = preferences.get_preferences().color_Modal_Displace

    font_id = 0
    blf.position(font_id, x, y, 0)
    blf.size(font_id, 30)
    blf.color(font_id, pink_mod[0], pink_mod[1], pink_mod[2], pink_mod[3])
    blf.enable(font_id, blf.SHADOW)
    blf.shadow(font_id, 5, 0.0, 0.0, 0.0, .6)
    blf.shadow_offset(font_id, 3, -3)

    xs = preferences.get_preferences().x_position_shortcuts
    ys = height - preferences.get_preferences().y_position_shortcuts
    size_1 = preferences.get_preferences().size_shortcuts

    font_id2 = 1
    blf.enable(1, blf.WORD_WRAP)
    blf.word_wrap(1, 500)
    blf.position(font_id2, xs, ys, 0)
    blf.size(font_id2, size_1)
    blf.color(font_id2, 1, 1, 1, 1)
    blf.enable(font_id2, blf.SHADOW)
    blf.shadow(font_id2, s, h, a, d, o)
    blf.shadow_offset(font_id2, sx, sy)

    font_id3 = 2
    blf.enable(2, blf.WORD_WRAP)
    blf.word_wrap(2, 1200)
    blf.position(font_id3, x, y - 40, 0)
    blf.size(font_id3, size_1)
    blf.color(font_id3, 1, 1, 1, 1)
    blf.enable(font_id3, blf.SHADOW)
    blf.shadow(font_id3, s, h, a, d, o)
    blf.shadow_offset(font_id3, sx, sy)

    font_id4 = 3
    blf.position(font_id4, xs + 50, ys + 50, 0)
    blf.size(font_id4, 20)
    blf.color(font_id4, pink_mod[0], pink_mod[1], pink_mod[2], pink_mod[3])

    str_3 = "\n".join((
        "",
        "Modal Displace Shortcuts:",
        "",
        "Scroll           +-  .1 strenght",
        "Scroll-Shift     +- .01 strenght",
        "",
        "Scroll-Ctrl      +-  5 Blur",

    ))

    if preferences.get_preferences().Display_Shortcuts_Modal_Uv:
        blf.draw(font_id3,
                 "Validate: 'RETURN','NUMPAD_ENTER','BUTTON 5 MOUSE' or 'Validate Custom Shortcut'\nEscape  :'Esc'")

    blf.draw(font_id, "III  Modal Displace  III")
    blf.draw(font_id2, str_3)


    blf.disable(1, blf.WORD_WRAP)
    blf.disable(2, blf.WORD_WRAP)