import pkgutil
import importlib
from pathlib import Path

modules = None


def init():
    global modules
    modules = get_all_submodules(Path(__file__).parent)


def reload():
    for module in modules:

        if module.__file__ is __file__:
            continue

        try:
            print('relaod', module)
            importlib.reload(module)
        except:
            pass


def get_all_submodules(directory):
    return list(iter_submodules(directory, directory.name))


def iter_submodules(path, package_name):
    for name in sorted(iter_submodule_names(path)):
        yield importlib.import_module("." + name, __package__)


def iter_submodule_names(path, root=""):
    for _, module_name, is_package in pkgutil.iter_modules([str(path)]):
        if is_package:
            sub_path = path / module_name
            sub_root = root + module_name + "."
            yield from iter_submodule_names(sub_path, sub_root)
        else:
            yield root + module_name
