import bpy

from pathlib import Path

CUSTOM_ICONS = dict()

def get_icon_id(name):
    return CUSTOM_ICONS[name].icon_id


def register():
    global CUSTOM_ICONS

    icons_dir = Path(__file__).parent / "icons"
    CUSTOM_ICONS = bpy.utils.previews.new()

    CUSTOM_ICONS.load("custom_unwrap", str(icons_dir / "unwrap.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_viewproj", str(icons_dir / "viewproj.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_cubeproj", str(icons_dir / "cubeproj.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_cylinderproj", str(icons_dir / "cylinderproj.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_facemap", str(icons_dir / "facemap.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_unwrapp", str(icons_dir / "unwrap.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_material", str(icons_dir / "material.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_gizmo", str(icons_dir / "gizmo2.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_aligntoface", str(icons_dir / "aligntoface.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_rotate", str(icons_dir / "rotate.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_scale", str(icons_dir / "scaleModal.png"), 'IMAGE')
    CUSTOM_ICONS.load("custom_sphere", str(icons_dir / "sphereproj.png"), 'IMAGE')


def unregister():
    global CUSTOM_ICONS
    bpy.utils.previews.remove(CUSTOM_ICONS)