import bpy
from bpy.props import (
    BoolProperty,
    PointerProperty,
    EnumProperty
)

class QupObjectProps(bpy.types.PropertyGroup):

    # lock_ratio: BoolProperty(name='Lock Gizmo Ratio', default=False, update=bpy.ops.qup.gizmo_lock_ratio('INVOKE_DEFAULT'))
    @staticmethod
    def lock_ratio():
        name = 'Lock gizmo ratio'
        default = False

        def get(self):
            obj = self.id_data

            obj = bpy.context.object
            Node_tree = obj.parent.active_material.node_tree
            Nodes = Node_tree.nodes
            for n in Nodes:
                if n.type == 'TEX_IMAGE':
                    size_img = n.image.size

            ratio = size_img[0] / size_img[1]
            x = obj.dimensions[0]
            y = obj.dimensions[1]

            if x/y == ratio:
                return True

        def update(self, context):
            bpy.ops.qup.gizmo_lock_ratio('INVOKE_DEFAULT')

    # lock_ratio: BoolProperty(**lock_ratio())
    lock_ratio: BoolProperty()

def register():
    bpy.utils.register_class(QupObjectProps)
    bpy.types.Object.qup = PointerProperty(type=QupObjectProps)


def unregister():
    bpy.utils.unregister_class(QupObjectProps)
    del bpy.types.Object.qup
