import bpy
import os
from os import listdir
from .custom_icons import get_icon_id
from bpy.props import IntProperty
from . import preferences

from . __init__ import error_gizmo
def has_world_gizmo(self):
    obj = bpy.context.object
    parent = obj.parent
    tc = obj.active_material.node_tree.nodes.get("Texture Coordinate", None)
    if tc is not None and tc.object is not None and tc.object.name.startswith('Gizmo_WORLD'):
    # if tc and tc.object and tc.object.name.startswith('Gizmo_WORLD'):
        return True
    else:
        return False

    # return {'FINISHED'}

class QUP_MT_pie_uv_pro(bpy.types.Menu):
    bl_label = "Quick Uv Pro Pie"

    def draw(self, context):
        layout = self.layout

        pie = layout.menu_pie()
        obj = bpy.context.object
        pref = bpy.context.preferences.addons[__package__].preferences
        if hasattr(obj,"type"):
            if obj.type == 'LIGHT':

                scn = bpy.context.object
                box = pie.split().box().column()
                box.label(text='Light Texture paths')
                if not pref.light_texture_path:
                    box.operator("qup.add_light_file_path", icon= "PLUS", text=" Add Light Texture Path")

                else:
                    box.template_icon_view(scn.qup, "previews_light_texture", show_labels=True, scale=8, scale_popup=8)
                box.separator()

                box.operator("qup.light_texture", text="Other Path for Light Texture",
                            icon="FILE_FOLDER").directory = pref.light_texture_path

                box = pie.split().box().column()
                box.label(text='ies Texture paths')

                if not pref.ies_texture_path:
                    box.operator("qup.add_ies_file_path", icon="PLUS", text=" Add ies Texture Path")
                else:
                    box.template_icon_view(scn.qup, "previews_ies_texture", show_labels=True, scale=8, scale_popup=8)
                box.separator()

                box.operator("qup.ies_light_texture", text="Other Path for ies Light Texture",
                            icon="FILE_FOLDER").directory = pref.ies_texture_path


            else:
                obj = bpy.context.object


                G = [obj for obj in bpy.context.object.children if obj.name.startswith("Gizmo_WORLD")]

                pie.operator("qup.modal_uv", text="Modal Uv", icon_value=get_icon_id("custom_scale"))

                pie.operator("qup.uv_fromview", text="Proj From View", icon_value=get_icon_id("custom_viewproj"))

                box = pie.split().box().column()

                box.operator("QUP.uv_cube", text="CUBE PROJ", icon_value=get_icon_id("custom_cubeproj"))
                box.operator("qup.uv_cylinder", text="CYLINDER PROJ", icon_value=get_icon_id("custom_cylinderproj"))
                box.operator("qup.uv_sphere", text="SPHERE PROJ", icon_value=get_icon_id("custom_sphere"))

                box.separator()
                box.operator("object.add_mat_nw", text="Node Wrangler Uv", icon="SHADING_TEXTURE")

                box.operator("qup.add_one_texture_material", text="One Texture Material Uv", icon="SHADING_RENDERED")
                box.separator()
                row = box.row(align=True)
                row.operator("qup.add_world_material", text="World Material With Gizmos", icon="SHADING_WIRE")

                # G = [obj for obj in bpy.context.object.children if obj.name.startswith("Gizmo_WORLD")]
                # if len(G) != 0:

                tc = obj.active_material.node_tree.nodes.get("Texture Coordinate", None)

                if tc is not None and tc.object is not None and tc.object.name.startswith('Gizmo_WORLD'):
                    row.operator("qup.select_world_gizmo", text="", icon="OBJECT_HIDDEN")


                box.separator()
                row = box.row(align=True)
                row.operator("qup.draw_qup_mat", text="Tweak Materials", icon="NODE_MATERIAL")


                box.separator()

                row = box.row(align=True)
                if preferences.get_preferences().Display_Experimental:
                    row.operator("qup.displace_map", text="Add Dispalcement Map", icon="MOD_DISPLACE")
                    row.operator("qup.displace_modal", text="", icon="SETTINGS")

                box.separator()
                box.operator("align.viewtoface", text="Align View", icon_value=get_icon_id("custom_aligntoface"))

                # box = pie.split().box().column()
                pie.operator("uv.unwrap", text="Unwrap", )
                # box.operator("qup.uv_straight_unwrap", text="Straight Unwrap", icon_value=get_icon_id("custom_unwrapp"))

                mc = [modifier for modifier in obj.modifiers if modifier.name.startswith("QuickUVProject_Cube")]
                mp = [modifier for modifier in obj.modifiers if modifier.name.startswith("QuickUVProject_Plane")]

                box = pie.split().box().column()
                row = box.row()
                row.operator("uv.rotate", text="Rotate Uvs", icon_value=get_icon_id("custom_rotate"))
                # if len(mc) <1 and len(mp) <1 :
                row.operator("qup.deg_rotate_uv", text="", icon="SETTINGS")

                box = pie.split().box().column()
                column = box.column(align=True)
                row = column.row(align=True)
                r = row.row(align=True)
                if len(mc) == 0 and len(mp) == 0:
                    r.operator("qup.gizmo_plane", text="Plane Gizmo", icon_value=get_icon_id("custom_facemap"))
                for modifier in obj.modifiers:
                    if modifier.name.startswith("QuickUVProject_Plane"):
                        if len(bpy.context.selected_objects) > 1:
                            r.operator("qup.copy_gizmo_modifier", text="", icon="LINKED").param_gizmo = 'P'
                            r.separator()
                        r.operator("qup.select_plane_gizmo", text="Select Plane Gizmo", icon="OBJECT_HIDDEN")
                        r.separator()
                        r.operator("qup.apply_gizmo", text="", icon="IMPORT").param_gizmo = 'P'

                box = pie.split().box().column()
                column = box.column(align=True)
                row = column.row(align=True)
                r = row.row(align=True)
                box.operator("qup.copy_material", text="Link Material", icon_value=get_icon_id("custom_material"))
                box.operator("qup.draw_qup_mat", text="Tweak Materials", icon="NODE_MATERIAL")

                box = pie.split().box().column()
                column = box.column(align=True)
                row = column.row(align=True)
                r = row.row(align=True)
                for modifier in obj.modifiers:
                    if modifier.name.startswith("QuickUVProject_Cube"):
                        if len(bpy.context.selected_objects) > 1:
                            r.operator("qup.copy_gizmo_modifier", text="", icon="LINKED").param_gizmo = 'C'
                            r.separator()
                        r.operator("qup.select_cube_gizmo", text="Select Cube Gizmo", icon="OBJECT_HIDDEN")
                        r.separator()
                        r.operator("qup.apply_gizmo", text="", icon="IMPORT").param_gizmo = 'C'
                if len(mc) == 0 and len(mp) == 0 and obj:
                    r.operator("qup.gizmo_cube", text="Cube Gizmo", icon_value=get_icon_id("custom_gizmo"))
                # box.operator("qup.uv_gizmo_world", text="World Gizmos", icon="SHADING_WIRE")

                    # pie.operator("qup.uv_gizmo_world", text='Add World Gizmo', icon='PLUS')

        else:
            pie.label(text="没有选择物体", icon="ERROR")
class QUP_MT_pie_uv_modal(bpy.types.Menu):
    bl_label = "Quick UV Modal Pie"

    def draw(self, context):
        obj = bpy.context.object
        mc = [modifier for modifier in obj.modifiers if modifier.name.startswith("QuickUVProject_Cube")]
        mp = [modifier for modifier in obj.modifiers if modifier.name.startswith("QuickUVProject_Plane")]

        layout = self.layout

        pie = layout.menu_pie()

        box = pie.split().box().column()
        row = box.row(align=True)
        row.label(text="Modal is Running :)", icon="FRAME_NEXT")

        pie.operator("qup.uv_fromview", text="PROJ FROM VIEW", icon_value=get_icon_id("custom_viewproj"))

        box = pie.split().box().column()

        box.operator("qup.uv_cube", text="Cube Proj", icon_value=get_icon_id("custom_cubeproj"))
        box.operator("qup.uv_cylinder", text="Cylinder Proj", icon_value=get_icon_id("custom_cylinderproj"))
        box.operator("qup.uv_sphere", text="Sphere Proj", icon_value=get_icon_id("custom_sphere"))

        box.separator()
        box.operator("align.viewtoface", text="Align View", icon_value=get_icon_id("custom_aligntoface"))


        # pie.operator("qup.uv_straight_unwrap", text="Straight Unwrap", icon_value=get_icon_id("custom_unwrapp"))
        pie.separator()

        # pie.operator("uv.rotate", text="Rotate Uvs", icon_value=get_icon_id("custom_rotate"))
        box = pie.split().box().column()
        row = box.row()
        row.operator("uv.rotate", text="Rotate Uvs", icon_value=get_icon_id("custom_rotate"))
        if len(mc) < 1 and len(mp) < 1:
            row.operator("qup.deg_rotate_uv", text="", icon="SETTINGS")

        box = pie.split().box().column()
        row = box.row(align=True)
        row.label(text="Gizmo /// Pause", icon="PAUSE")

        pie.operator("qup.copy_material", text="Link Material", icon_value=get_icon_id("custom_material"))

        box = pie.split().box().column()
        row = box.row(align=True)
        row.label(text="Real Size Gizmo /// Pause", icon="PAUSE")


tex_nodes=['TEX_IMAGE',
          'TEX_BRICK',
          'TEX_CHECKER',
          'TEX_IES',
          'TEX_MAGIC',
          'TEX_MUSGRAVE',
          'TEX_NOISE',
          'TEX_POINTDENSITY',
          'TEX_VORONOI',
          'TEX_WAVE',
          'TEX_WHITE_NOISE']

class QUP_MT_pie_images_nodes(bpy.types.Menu):
    bl_label = "Texture Shader Pie"
    index_prev = []
    default: IntProperty()


    def draw(self, context):

        obj = context.object

        mat = bpy.context.object.active_material
        nt = context.object.active_material.node_tree
        nodes = nt.nodes
        node = nodes.active
        bsdf_Node = mat.node_tree.nodes.get('Principled BSDF')



        if obj.type in {'MESH', 'CURVE'}:
            node = context.object.active_material.node_tree.nodes.active
        if obj.type in {'LIGHT'}:
            node = context.object.data.node_tree.nodes.active

        layout = self.layout
        pie = layout.menu_pie()

        # if context.object.active_material.node_tree.nodes.active.type in tex_nodes:
        if node.type in tex_nodes:
            # node = context.object.active_material.node_tree.nodes.active
            if bpy.context.preferences.filepaths.image_editor:
                pie.operator("qup.launch_external_soft", text='Open in PSD', icon='SEQ_PREVIEW')

            else:
                pie.operator("qup.add_file_path_image_editor", text='Add Images Editor Path', icon='PLUS')



            pie.operator("qup.reload_img", text='Reload Images', icon='FILE_REFRESH')
            box = pie.split().box().column()
            box.operator("qup.pack_img", text='Pack Image', icon='IMPORT')
            box.operator("qup.unpack_img", text='Unpack Image', icon='EXPORT')
            box.separator()
            box.operator("qup.relative_img", text='Relative Path', icon='FILE_BLEND')

            # if preferences.get_preferences().Display_Experimental:
            #     pie.template_icon_view(node.qup, "my_previews_texture", show_labels=True, scale=8, scale_popup=5)
            # else:

            pie.separator()

            pie.operator("qup.one_texture_group", text='Add One Texture Node' ,icon='PLUS')

            box = pie.split().box().column()
            box.operator("qup.add_occlusion_node", text='Add Aged Texture Nodes' ,icon='PLUS')
            box.operator("qup.add_simple_ao", text='Add Occlusion Nodes' ,icon='PLUS')
            box.operator("qup.add_blur", text='Add Blur Node' ,icon='PLUS')
            if bsdf_Node:
                box.operator("qup.add_bevel_node", text='Add Bevel Node' ,icon='PLUS')

            pie.operator("qup.add_gizmo_world", text='Add World Gizmo' ,icon='PLUS')
            box = pie.split().box().column()
            box.operator("qup.add_bump_node", text='Add Bump Node' ,icon='PLUS')
            box.operator("qup.add_normal_node", text='Add Normal Node' ,icon='PLUS')
            box.operator("qup.add_displace_node", text='Add Displace Node', icon='PLUS')

        # if node.type == 'GROUP' and node.namenode_tree.name =='One_Texture_Shader':
        # if node.type == 'GROUP' :
        elif node.type == 'GROUP' and node.node_tree.name.startswith('One_Texture_Shader'):
        # else:
            pie.separator()
            pie.separator()
            pie.separator()
            # box = pie.split().box().column()
            # box.operator("qup.replace_onetexturenode", text='Replace by a P-BSDF Node', icon='ARROW_LEFTRIGHT')
            pie.separator()

        elif node.type == 'BSDF_PRINCIPLED':
        # else:
            pie.separator()
            pie.separator()
            # pie.separator()
            pie.operator("qup.add_bevel_node", text='Add Bevel Node', icon='PLUS')
            # box = pie.split().box().column()
            # pie.operator("qup.replace_p_bsdf", text='Replace by a One Texture Node', icon='ARROW_LEFTRIGHT')
            pie.separator()

        else:
            pie.separator()
            pie.separator()
            pie.separator()
            box = pie.split().box().column()
            box.label(text="No Operator available fo this NodeType for now",icon='ERROR' )

class QUP_OT_add_file_path_light(bpy.types.Operator):
    """Set Main Properties"""
    bl_label = "Add Path for Light Texture"
    bl_idname = "qup.add_light_file_path"

    def execute(self, context):
        return {'FINISHED'}

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self, width=150)

    def draw(self, context):
        # wm = context.window_manager
        layout = self.layout
        pref = bpy.context.preferences.addons[__package__].preferences
        layout.prop(pref, "light_texture_path", text="")


class QUP_OT_add_file_path_ies(bpy.types.Operator):
    """Set Main Properties"""
    bl_label = "Add Path for ies Texture"
    bl_idname = "qup.add_ies_file_path"

    def execute(self, context):
        return {'FINISHED'}

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self, width=150)

    def draw(self, context):
        # wm = context.window_manager
        layout = self.layout
        pref = bpy.context.preferences.addons[__package__].preferences
        layout.prop(pref, "ies_texture_path", text="")

class QUP_OT_add_file_path_image_editor(bpy.types.Operator):
    """Set Main Properties"""
    bl_label = "Add Path for Image Editor"
    bl_idname = "qup.add_file_path_image_editor"

    def execute(self, context):
        return {'FINISHED'}

    def invoke(self, context, event):
        return context.window_manager.invoke_popup(self, width=180)

    def draw(self, context):

        layout = self.layout
        paths = context.preferences.filepaths
        layout.prop(paths, "image_editor", text="Path")

class QUP_OT_deg_rotate_uv(bpy.types.Operator):
    '''15,30,45,90,180° Incrementation'''
    bl_label = "Rotation Degree"
    bl_idname = "qup.deg_rotate_uv"

    def execute(self, context):

        return {'FINISHED'}

    def invoke(self, context, event):
        obj = bpy.context.object
        mc = [modifier for modifier in obj.modifiers if modifier.name.startswith("QuickUVProject_Cube")]
        mp = [modifier for modifier in obj.modifiers if modifier.name.startswith("QuickUVProject_Plane")]
        # G = [obj for obj in bpy.context.object.children if obj.name.startswith("Gizmo_WORLD")]

        if len(mc) > 0 or len(mp) > 0:
            self.report({'ERROR'}, " !!! This Mesh has a Uv Gizmo. Uv Handlers won't work"
                                   " \n Use Gizmo Instead or Apply it and then use Handlers")
            return {'FINISHED'}

        return context.window_manager.invoke_popup(self, width=80,)

    def draw(self, context):

        layout = self.layout

        layout.label(text='',icon='GRIP')
        layout.label(text='Uv Rotation °',)
        for d in (15, 30, 45, 90, 180):
            split = layout.split()

            col_1 = split.column()
            col_2 = split.column()
            col_3 = split.column()
            col_1.operator("qup.rotate_uv_deg", text='', icon='REMOVE').param_deg = f'-{d}'
            r = col_2.row()
            r.alignment = 'CENTER'
            r.label(text=f'{d}', )
            col_3.operator("qup.rotate_uv_deg", text='', icon='ADD''').param_deg = f'{d}'
        layout.operator("qup.uv_cube", text='Reset to 0°', )


class QUP_OT_shortcut_popup(bpy.types.Operator):
    '''Shortcut_popup'''
    bl_label = "Shortcut_popup"
    bl_idname = "qup.shortcut_popup"

    def execute(self, context):

        return {'FINISHED'}

    def invoke(self, context, event):

        return context.window_manager.invoke_popup(self, width=130,)

    def draw(self, context):
        pref = bpy.context.preferences.addons[__package__].preferences
        obj= context.object
        layout = self.layout

        layout.label(text='Shortcuts Position', icon='GRIP')
        box = layout.column(align=True)
        row = box.row()
        box.prop(pref, "Display_Shortcuts_Modal_Uv", text='Dispaly Shortcuts ')
        box.prop(pref, 'x_position_shortcuts', text='X Position', )
        box.prop(pref, 'y_position_shortcuts', text='Y Position', )
        box.prop(pref, 'size_shortcuts', text='Size', )

        layout.label(text='Modal Shortcuts', icon='GRIP')
        box = layout.column(align=True)
        box.prop(pref, 'x_modal_shortcuts', text='X Position', )
        box.prop(pref, 'y_modal_shortcuts', text='Y Position', )
        box.prop(pref, 'size_modal_shortcuts', text='Size', )
        if obj.name.startswith('Gizmo_WORLD'):
            box.prop(pref, "Color_World_Gizmo", text='Modal Uv Color')
        else:
            box.prop(pref, "Text_Color_Modal_Uv", text='Modal Uv Color')




register, unregister = bpy.utils.register_classes_factory((
    QUP_MT_pie_uv_pro,
    QUP_MT_pie_uv_modal,
    QUP_MT_pie_images_nodes,
    QUP_OT_add_file_path_light,
    QUP_OT_add_file_path_ies,
    QUP_OT_add_file_path_image_editor,
    QUP_OT_deg_rotate_uv,
    QUP_OT_shortcut_popup,

))