import bpy
import os
from bpy.props import IntProperty, FloatProperty, FloatVectorProperty, StringProperty, CollectionProperty, PointerProperty, EnumProperty
# from bpy.types import Operator, Panel, Menu,
from bpy_extras.io_utils import ImportHelper, ExportHelper
from bpy.types import Menu, Operator, Panel, UIList
from bpy.props import *


class QUP_select_mat1(bpy.types.Operator):
    # '''Select Material  Gizmodfsbsdfbsdbbd'''
    bl_label = "Select Material Gizmo"
    bl_idname = "qup.select_mat_gizmo"

    param_gizmo_t: StringProperty()

    def execute(self, context):
        obj=context.object
        for objs in context.scene.collection.all_objects:
            objs.select_set(False)
        objects_in_collection = bpy.data.collections["UV_GIZMO"].all_objects
        nodes = context.object.active_material.node_tree.nodes

        if self.param_gizmo_t == 'Material 1':
            for obj in list(objects_in_collection):
                if obj.name.startswith('Gizmo_WORLD.mAT1'):
                    bpy.context.view_layer.layer_collection.children["UV_GIZMO"].exclude = False
                    obj.hide_select = False
                    obj.select_set(True)
        if self.param_gizmo_t == 'Material 2':
            for obj in list(objects_in_collection):
                if obj.name.startswith('Gizmo_WORLD.mAT2'):
                    bpy.context.view_layer.layer_collection.children["UV_GIZMO"].exclude = False
                    obj.hide_select = False
                    obj.select_set(True)

        return {'FINISHED'}

class QUP_OT_draw_mask(bpy.types.Operator):
    '''Draw_Mask'''
    bl_label = "Draw Mask"
    bl_idname = "qup.draw_mask"

    def execute(self, context):
        obj=context.object
        nodes = context.object.active_material.node_tree.nodes
        for node in nodes:
            if node.type == 'TEX_IMAGE' and node.image.name == 'QUP_TERRAIN_MASK':
                node.select = True
                context.object.active_material.node_tree.nodes.active = node

        bpy.ops.paint.texture_paint_toggle()

        return {'FINISHED'}


def set_scale_mat1(self, context):
    Giz1 = bpy.context.scene.collection.all_objects['Gizmo_WORLD.mAT1']
    val = self.scale_Mat1
    Giz1.scale[0] = val
    Giz1.scale[1] = val
    Giz1.scale[2] = val

def set_rotation_mat1(self, context):
    Giz1 = bpy.context.scene.collection.all_objects['Gizmo_WORLD.mAT1']
    val = self.rotation_Mat1
    Giz1.rotation_euler[2] = val


def set_scale_mat2(self, context):
    Giz2 = bpy.context.scene.collection.all_objects['Gizmo_WORLD.mAT2']
    val = self.scale_Mat2
    Giz2.scale[0] = val
    Giz2.scale[1] = val
    Giz2.scale[2] = val

def set_rotation_mat2(self, context):
    Giz2 = bpy.context.scene.collection.all_objects['Gizmo_WORLD.mAT2']
    val = self.rotation_Mat2
    Giz2.rotation_euler[2] = val
class QUP_OT_terrain_popup(bpy.types.Operator):
    '''terrain'''
    bl_label = "Terrain"
    bl_idname = "qup.terrain"

    def execute(self, context):


        return {'FINISHED'}

    def invoke(self, context, event):

        return context.window_manager.invoke_popup(self, width=250,)

    def draw(self, context,):
        obj = context.object
        Giz1 = bpy.context.scene.collection.all_objects['Gizmo_WORLD.mAT1']
        Giz2 = bpy.context.scene.collection.all_objects['Gizmo_WORLD.mAT2']

        node_mat1 = bpy.data.materials['QUP_TERRAIN'].node_tree.nodes["MAT 1"]
        node_mat2 = bpy.data.materials['QUP_TERRAIN'].node_tree.nodes["MAT 2"]

        mat1_h = node_mat1.inputs[1]
        mat1_s = node_mat1.inputs[2]
        mat1_v = node_mat1.inputs[3]
        mat1_b = node_mat1.inputs[8]

        mat2_h = node_mat2.inputs[1]
        mat2_s = node_mat2.inputs[2]
        mat2_v = node_mat2.inputs[3]
        mat2_b = node_mat2.inputs[8]

        image1 = node_mat1.inputs[0].links[0].from_node.image
        image2 = node_mat2.inputs[0].links[0].from_node.image

        layout = self.layout

        layout.label(text='Terrain',icon='GRIP')
        box = layout.box()
        row = box.row(align=True)
        row.label(text='Material 1',)
        row = box.row(align=True)
        row.label(text=image1.name, icon_value=image1.preview.icon_id,)
        col = box.column(align=True)
        col.prop(Giz1, "scale_Mat1", text="Scale",)
        col.prop(Giz1, "rotation_Mat1", text="Rotation",)
        col.separator()
        col.prop(mat1_h, "default_value", text="Hue",)
        col.prop(mat1_s, "default_value", text="Saturation",)
        col.prop(mat1_v, "default_value", text="Value",)
        col.separator()
        col.prop(mat1_b, "default_value", text="Bump",)

        row.operator("qup.select_mat_gizmo", text="", icon="OBJECT_HIDDEN").param_gizmo_t = 'Material 1'

        box = layout.box()
        row = box.row(align=True)
        row.label(text='Material 2', )
        row = box.row(align=True)
        row.label(text=image2.name, icon_value=image2.preview.icon_id)
        col = box.column(align=True)
        col.prop(Giz2, "scale_Mat2", text="Scale", )
        col.prop(Giz2, "rotation_Mat2", text="Rotation", )
        col.separator()
        col.prop(mat2_h, "default_value", text="Hue", )
        col.prop(mat2_s, "default_value", text="Saturation", )
        col.prop(mat2_v, "default_value", text="Value", )
        col.separator()
        col.prop(mat2_b, "default_value", text="Bump", )

        row.operator("qup.select_mat_gizmo", text="", icon="OBJECT_HIDDEN").param_gizmo_t = 'Material 2'

        box = layout.box()
        row = box.row(align=True)
        row.label(text='Mask', )
        row.operator("qup.draw_mask", text="", icon="BRUSH_DATA")
        texts = 'image*' if bpy.data.images["QUP_TERRAIN_MASK"].is_dirty else 'image'
        row.separator()
        row.operator("qup.save_image", text=texts , icon="FILE_TICK")


class QUP_OT_save_image(bpy.types.Operator):
    """Save Terrain Mask Image"""
    bl_label = "Save Terrain Mask Image"
    bl_idname = "qup.save_image"
    def execute(self, context):

        im = bpy.data.images["QUP_TERRAIN_MASK"]
        bpy.context.area.ui_type = 'UV'
        bpy.ops.image.save()
        bpy.context.area.ui_type = 'VIEW_3D'

        return {'FINISHED'}

def get_active_tree(context):
    tree = context.object.active_material.node_tree
    path = []
    return tree, path

def get_nodes_links(context):
    tree, path = get_active_tree(context)
    return tree.nodes, tree.links

class QUP_OT_multiple_images(bpy.types.Operator, ImportHelper):
    """Add multiple images at once"""
    bl_idname = 'qup.multiple_images'
    bl_label = 'Open Selected Images at Once'
    bl_options = {'REGISTER', 'UNDO'}
    directory: StringProperty(
        subtype="DIR_PATH"
    )
    files: CollectionProperty(
        type=bpy.types.OperatorFileListElement,
        options={'HIDDEN', 'SKIP_SAVE'}
    )

    def execute(self, context):
        nodes, links = get_nodes_links(context)

        xloc, yloc = context.region.view2d.region_to_view(context.area.width/2, context.area.height/2)

        node_type = "ShaderNodeTexImage"

        new_nodes = []
        for f in self.files:
            fname = f.name

            node = nodes.new(node_type)
            new_nodes.append(node)
            node.label = fname

            node.location.x = xloc
            node.location.y = yloc
            yloc -= 40

            img = bpy.data.images.load(self.directory+fname)
            node.image = img

        list_size = new_nodes[0].location.y - new_nodes[-1].location.y
        for node in nodes:
            if node in new_nodes:
                node.select = True
                node.location.y += (list_size/2)
            else:
                node.select = False
        return {'FINISHED'}


classes = {
    QUP_OT_multiple_images,
    QUP_OT_save_image,
    QUP_OT_terrain_popup,
    QUP_OT_draw_mask,
    QUP_select_mat1,

}

addon_keymaps = []

def register():

    for cls in classes:
        bpy.utils.register_class(cls)

    bpy.types.Object.scale_Mat1 = FloatProperty(name="Scale Mat1 ", default=1, update=set_scale_mat1)
    bpy.types.Object.rotation_Mat1 = FloatProperty(name="Rotation Mat1 ", default=1, update=set_rotation_mat1)

    bpy.types.Object.scale_Mat2 = FloatProperty(name="Scale Mat2 ", default=1, update=set_scale_mat2)
    bpy.types.Object.rotation_Mat2 = FloatProperty(name="Rotation Mat2 ", default=1, update=set_rotation_mat2)

#
def unregister():

    for cls in classes:
        bpy.utils.unregister_class(cls)

    del bpy.types.Object.scale_Mat1
    del bpy.types.Object.rotation_Mat1


    del bpy.types.Object.scale_Mat2
    del bpy.types.Object.rotation_Mat2


